/* Nessus Attack Scripting Language version 2
 *
 * Copyright (C) 2002 Michel Arboi
 *
 * En quelques mots : ceci n'est pas un logiciel libre.
 *
 * Ce logiciel "NASL2" n'est pas termin. Il reste ma proprit jusqu' ce 
 * que je dcide de changer la licence.
 * En attendant, vous avez le droit de linker avec le code sous GPL "Nessus", 
 * provenant de http://www.nessus.org,  fin de tests ou pour votre propre 
 * usage ducatif ou priv.
 * Vous n'avez pas le droit de revendre sous quelque forme que ce soit le
 * logiciel NASL2 ou ses rsultats ; cette restriction s'applique  tout 
 * logiciel link avec NASL2, ou incluant une partie de code provenant de
 * NASL2.
 *
 * Ce programme est distribu en esprant qu'il sera utile, mais SANS AUCUNE
 * GARANTIE.
 * Si vous n'acceptez pas ce point, veuillez me contacter pour acheter une
 * licence commerciale.
 *
 * [quick & dirty english translation. In case of conflict, French version
 *  prevails]
 *
 * In a few words: this is *not* free software.
 *
 * This "NASL2" software is unfinished. It is proprietary software until 
 * I decide to switch to another licence.
 * Meanwhile, you may link it with the GPL-ed "Nessus" software, from 
 * http://www.nessus.org, and use it for testing or for your own edutionnal 
 * or private use.
 * You are not allow to sell either this NASL2 software or its outputs;
 * the same restriction applies to any software linked with NASL2, or that
 * includes a part of NASL2 code.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * If you do not accept this last point, please contact me and buy a commercial
 * licence.
 */

#include "includes.h"
#include "nasl_func.h"
#include "nasl_tree.h"
#include "nasl_var.h"
#include "nasl_global_ctxt.h"
#include "nasl_lex_ctxt.h"

lex_ctxt*
init_empty_lex_ctxt()
{
  lex_ctxt	*c = emalloc(sizeof(lex_ctxt));
  int		i;

  for (i = 0; i < VAR_NAME_HASH; i ++)
    c->variables[i] = c->arrays[i] = NULL;
  for (i = 0; i < FUNC_NAME_HASH; i ++)
    c->functions[i] = NULL;
  c->ret_val = NULL;
  c->fct_ctxt = 0;
  return c;
}

void
free_lex_ctxt(lex_ctxt* c)
{
  int	i;

#if 0
  if (c->exit_flag && c->up_ctxt != NULL)
    ((lex_ctxt*)c->up_ctxt)->exit_flag = 1;
#endif
  deref_cell(c->ret_val);
  for (i = 0; i < VAR_NAME_HASH; i ++)
    {
      free_var_chain(c->variables[i]);
      free_var_chain(c->arrays[i]);
    }
  for (i = 0; i < FUNC_NAME_HASH; i ++)
    {
      free_func_chain(c->functions[i]);
    }
  efree(&c);
}

lex_ctxt*
get_top_level_ctxt(lex_ctxt* ctxt)
{
  lex_ctxt	*top = ctxt;

  while (top->up_ctxt != NULL)
    top = top->up_ctxt;
  return top;
}

void
dump_ctxt(lex_ctxt* c)
{
  int	i;
  nasl_var	*v;
  nasl_func	*f;

  printf("--------<CTXT>--------\n");
  if (c->fct_ctxt)
    printf("Is a function context\n");
  if (c->up_ctxt == NULL)
    printf("Is the top level context\n");
  if (c->ret_val)
    {
      printf("Return value\n");
      nasl_dump_tree(c->ret_val);
    }

  printf("Variables:\n");
  for (i = 0; i < VAR_NAME_HASH; i ++)
    for (v = c->variables[i]; v != NULL; v=v->next_var)
      printf("%s\t", v->var_name);
  putchar('\n');

  printf("Functions:\n");
  for (i = 0; i < FUNC_NAME_HASH; i ++)
    for (f = c->functions[i]; f != NULL; f = f->next_func)
      printf("%s\t", f->func_name);
  putchar('\n');

  printf("----------------------\n");
}
