/* Nessus Attack Scripting Language version 2
 *
 * Copyright (C) 2002 Michel Arboi
 *
 * En quelques mots : ceci n'est pas un logiciel libre.
 *
 * Ce logiciel "NASL2" n'est pas termin. Il reste ma proprit jusqu' ce 
 * que je dcide de changer la licence.
 * En attendant, vous avez le droit de linker avec le code sous GPL "Nessus", 
 * provenant de http://www.nessus.org,  fin de tests ou pour votre propre 
 * usage ducatif ou priv.
 * Vous n'avez pas le droit de revendre sous quelque forme que ce soit le
 * logiciel NASL2 ou ses rsultats ; cette restriction s'applique  tout 
 * logiciel link avec NASL2, ou incluant une partie de code provenant de
 * NASL2.
 *
 * Ce programme est distribu en esprant qu'il sera utile, mais SANS AUCUNE
 * GARANTIE.
 * Si vous n'acceptez pas ce point, veuillez me contacter pour acheter une
 * licence commerciale.
 *
 * [quick & dirty english translation. In case of conflict, French version
 *  prevails]
 *
 * In a few words: this is *not* free software.
 *
 * This "NASL2" software is unfinished. It is proprietary software until 
 * I decide to switch to another licence.
 * Meanwhile, you may link it with the GPL-ed "Nessus" software, from 
 * http://www.nessus.org, and use it for testing or for your own edutionnal 
 * or private use.
 * You are not allow to sell either this NASL2 software or its outputs;
 * the same restriction applies to any software linked with NASL2, or that
 * includes a part of NASL2 code.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * If you do not accept this last point, please contact me and buy a commercial
 * licence.
 */

#ifndef NASL_LEX_CTXT_H_INCLUDED
#define NASL_LEX_CTXT_H_INCLUDED


typedef struct struct_lex_ctxt {
  struct struct_lex_ctxt	*up_ctxt;
  tree_cell	*ret_val;	/* return value or exit flag */
  unsigned	fct_ctxt :1;	/* This is a function context */
  struct arglist	*script_infos;
  int			recv_timeout;
  nasl_var	*variables[VAR_NAME_HASH];
  nasl_var	*arrays[VAR_NAME_HASH];
  nasl_func	*functions[FUNC_NAME_HASH];
} lex_ctxt;

#define NASL_COMPAT_LEX_CTXT	"NASL compat lex context"

lex_ctxt	*init_empty_lex_ctxt(void);
void		free_lex_ctxt(lex_ctxt*);
lex_ctxt	*get_top_level_ctxt(lex_ctxt*);

void		dump_ctxt(lex_ctxt*);

nasl_func	*get_func_ref_by_name(lex_ctxt*, const char*);
tree_cell	*decl_nasl_func(lex_ctxt*, tree_cell*);
nasl_func	*insert_nasl_func(lex_ctxt*, const char*, tree_cell*);
tree_cell*	nasl_func_call(lex_ctxt*, const nasl_func*, tree_cell*);

tree_cell	*get_variable_by_name(lex_ctxt*, const char*);
tree_cell	*get_array_elem(lex_ctxt*, const char* /*array name*/, tree_cell*);
nasl_var*	add_numbered_var_to_ctxt(lex_ctxt*, int, tree_cell*);
nasl_var*	add_named_var_to_ctxt(lex_ctxt*, const char*, tree_cell*);
tree_cell*	nasl_read_var_ref(lex_ctxt*, tree_cell*);
tree_cell* 	nasl_incr_variable(lex_ctxt*, tree_cell* , int , int );
tree_cell*	nasl_return(lex_ctxt*, tree_cell*);

tree_cell*  	decl_local_variables(lex_ctxt*, tree_cell*);
tree_cell*  	decl_global_variables(lex_ctxt*, tree_cell*);

tree_cell* 	cell2atom(lex_ctxt*, tree_cell*);


int		get_int_var_by_num(lex_ctxt*, int, int);
char*		get_str_var_by_num(lex_ctxt*, int);
int		get_int_var_by_name(lex_ctxt*, const char*, int);
int		get_int_local_var_by_name(lex_ctxt*, const char*, int);
char*		get_str_var_by_name(lex_ctxt*, const char*);
char*		get_str_local_var_by_name(lex_ctxt*, const char*);



#endif
